#pragma once

#define EMILUA_CONFIG_VERSION_MAJOR 0
#define EMILUA_CONFIG_VERSION_MINOR 6
#define EMILUA_CONFIG_VERSION_PATCH 0
#define EMILUA_CONFIG_VERSION_STRING "0.6.0"

#define EMILUA_CONFIG_LIBROOTDIR "/usr/local/lib"

#define EMILUA_CONFIG_ENABLE_PLUGINS 1
#define EMILUA_CONFIG_ENABLE_COLOR 1
#define EMILUA_CONFIG_ENABLE_FILE_IO 0
#define EMILUA_CONFIG_IPC_ACTOR_MESSAGE_MAX_MEMBERS_NUMBER 20

// == THREADS AVAILABILITY
//
// 0:: No threading support.
//
// 1 or higher:: Threads available.
//
// == EXECUTION CONTEXTS
//
// 0 or 1:: Only one thread may call io_context::run(). spawn_ctx_threads() will
// always fail with ENOSYS (even if called with 0).
//
// 2 or higher:: Multiple threads may call io_context::run().
// spawn_ctx_threads() fully implemented.
//
// == NOTES
//
// Decreasing this value will change the implementation assumptions and enable a
// few optimizations. Check
// <https://www.boost.org/doc/libs/1_72_0/doc/html/boost_asio/overview/core/concurrency_hint.html>
// for more info.
#define EMILUA_CONFIG_THREAD_SUPPORT_LEVEL 2
